var net = require('sk/node/io/net'),
	URLRequest = net.Request,
	load = net.loadRequest,
	spawn = require('child_process').spawn,
	fs = require('fs')

var Closure = 
{
	compress: function(input, output, callback)
	{
		var tmp = output+'.js';
		
		var child = spawn('java',['-jar',__dirname+'/compiler.jar','--js',input,'--js_output_file',tmp]);
		
		child.on('exit', function()
		{
			//bug fix
			
			var content = fs.readFileSync(tmp,'utf8');
			
			if(content.length > 0)
			fs.writeFileSync(output, content, 'utf8');
			
			fs.unlinkSync(tmp);
			callback();
		})
	},
	compile: function (script, ops, callback)
	{                                    
		if(!callback)
		{
			callback = ops;
			ops = {};
		}            
		else
		{
			ops = ops || {};      
		}

		var buffer =  escape(script.toString()).
		replace(/\+/g, '%2B').
		replace(/\*/g, '%2A').
		replace(/\//g, '%2F').
		replace(/\@/g, '%40');

		ops.output_info       = ops.output_info       || 'compiled_code';   
		ops.output_format     = ops.output_format     || 'text';         
		ops.warning_level     = ops.warning_level     || 'VERBOSE';
		ops.compilation_level = ops.compilation_level || 'SIMPLE_OPTIMIZATIONS';        
        ops.js_code = buffer;
		




		var request = new URLRequest('http://closure-compiler.appspot.com/compile');
		request.data = ops;
		request.method = 'POST';
		
		load(request,function(buffer)
		{                            
			if(buffer.substr(0,5) == 'Error')
			{   
				callback(buffer);
			}                    
			else
			{
				callback(false,buffer);
			}
		});
	}
}             


exports.Closure = Closure;                                                                                                

